/****************************************************************************
** $Id: glbox.h,v 1.5 1998/03/23 11:44:44 aavit Exp $
**
** Definition of GLBox
** This is a simple QGLWidget displaying an openGL wireframe box
**
****************************************************************************/

#ifndef GLBOX_H
#define GLBOX_H

#include <qgl.h>

#include  "glwindow.h"

#define  SITES_SIZE  10

class  ArrPoint3d;

//class Terrain;
//class TTriangle;
class  Vector3d;
class  PointPair;


class GLBox : public GLWindow
{
    Q_OBJECT
private:
    bool  f_draw_direct, f_smooth;
    bool  f_update_gl;

    PointPair  * p_diam_pair;

    //    void   deleteGLObject();
    ArrPoint3d   * p_arr;

public:
    int  grid_delta;

public:
    //void keyPressEvent( QKeyEvent *k );

    virtual void   getBBox( GBBox  * p_bb );
    virtual void   drawScene();

    GLBox( QWidget* parent, const char* name );

    ~GLBox();
    void drawTerrain();

    //static void  drawTriangle( void  * glbox_ptr, 
    //                           TTriangle  * tri );
    void  changeDispState();
    void  changeDispStateFlip();
    void  myUpdateGL() 
    {
        if  ( f_update_gl ) 
            updateGL();
    }
    void  setUpdateGL( bool  val ) {
        f_update_gl = val;
    }

    void   comp_diameter();

    //virtual void mousePressEvent ( QMouseEvent * );
public slots:

    void   load( const char  * filename );

protected:
    void   registerSite( const Vector3d  & ver );
        
    virtual GLuint 	makeObject();

private:
    void  * scene;
    void  * poly_scene;
};


#endif // GLBOX_H



