/****************************************************************************
** $Id: globjwin.h,v 1.3 1997/10/01 18:32:02 hanord Exp $
**
** Definition of GLObjectWindow widget class
** The GLObjectWindow contains a GLBox and three sliders connected to
** the GLBox's rotation slots.
**
****************************************************************************/

#ifndef GLOBJWIN_H
#define GLOBJWIN_H

#include <qwidget.h>
#include <qbutton.h>

class Terrain;
class GLBox;
class QSlider;
class QMenuBar;

class GLObjectWindow : public QWidget
{
    Q_OBJECT

    GLBox  * object_win;
    QButton  * pbLoad, * pbDiam;

public:
    GLObjectWindow( QWidget* parent = 0, const char* name = 0,
                    Terrain  * tr = 0 );
    void   read_status( char  * filename );
    void   write_status( char  * filename );
    QMenuBar  * compute_menu( GLObjectWindow  * ptr );

 public slots:
    void   btnLoadClicked();
    void   btnDiameterClicked();

protected:
    void   keyPressEvent( QKeyEvent *k );

};


#endif // GLOBJWIN_H
