/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
 * glwindow.h -
 *     Implements GLwindow with basic graphics operations.
 *
 * Copyright (C) 2000 Sariel Har-Peled
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA  02111-1307, USA.
 *
 * Code is based on code written by Michael Garland and demo program
 * in QT. Both sources fall under the GPL.
 * \*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

#ifndef  __GLWINDOW__H
#define  __GLWINDOW__H


#include <qgl.h>

class  Camera;
class  Arcball;
class  GBBox;

class GLWindow : public QGLWidget
{
    Q_OBJECT
private:
    bool  f_draw_direct;
    GLuint   gl_scene;
    Camera  * camera;
    Arcball  * arcball;

    bool  f_display_scene;

    void   deleteGLObject();

public:
    GLWindow( QWidget* parent, const char* name );

    ~GLWindow();

    virtual void  prepareGL();
    virtual void  drawScene() = 0;
    virtual void  getBBox( GBBox  * p_bb ) = 0;

    virtual void mousePressEvent ( QMouseEvent * );
    virtual void mouseReleaseEvent ( QMouseEvent * );
    virtual void mouseMoveEvent ( QMouseEvent * );

    void   prepareView();

    void  resetDisplay() {
        deleteGLObject();
    }

public slots:
    void   smartDrawScene();

protected:
    void   initializeGL();
    void   paintGL();
    void   resizeGL( int w, int h );
        
    //virtual GLuint 	makeObject();

    // public slots:
 //    void   load( const char  * filename );
};


#else   /* __GLWINDOW__H */
#error  Header file glwindow.h included twice
#endif  /* __GLWINDOW__H */

/* glwindow.h - End of File ------------------------------------------*/



