/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
 * heap.h -
 *     Defines a generic heap.
\*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

#ifndef  __HEAP__H
#define  __HEAP__H

typedef  int   ( *ptrCompareFunc )( void  * aPtr, void  * bPtr );
typedef  void  * voidPtr_t;

struct  heap_t
{
    voidPtr_t  * pArr;
    int  curr_size, max_size;   
    ptrCompareFunc  pCompFunc;
};


void  heap_init( heap_t  * pHeap, ptrCompareFunc  _pCompFunc );
void  heap_term( heap_t  * pHeap );

void  heap_insert( heap_t  * pHeap, void  * pData );
void  * heap_delete_max( heap_t  * pHeap );
bool  heap_is_empty( heap_t  * pHeap );


#else   /* __HEAP__H */
#error  Header file heap.h included twice
#endif  /* __HEAP__H */

/* heap.h - End of File ----------------------------------------------------*/
