/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
 * real.h -
 *     
\*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

#ifndef  __REAL__H
#define  __REAL__H

typedef  double  real;

#define  REAL_EPSILON  1e-7

inline bool  real_lesseq( const real  & a, const real  & b )
{
    return  ( a <= (b + REAL_EPSILON ) );
}

inline bool  real_eq( const real  & a, const real  & b )
{
    return  ( ( a <= (b + REAL_EPSILON ) )
              &&  ( b <= (a + REAL_EPSILON ) ) );
}

#else   /* __REAL__H */
#error  Header file real.h included twice
#endif  /* __REAL__H */

/* real.h - End of File ------------------------------------------*/
