/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
 * strech.C -
 *     
\*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

#include  <stdlib.h>
#include  <stdio.h>
#include  <assert.h>

#include  <stdlib.h>
#include  <stdio.h>
#include  <iostream>
#include  <ctype.h>
#include  <math.h>
#include  <time.h>
#include  <qapplication.h>
#include  <assert.h>
#include  <GL/glut.h>

//#include  "dmalloc.h"

//#include  "scape/vector3d.h"
#include  "_generic.h"
#include  "sarray.h"
#include  "real.h"
//#include  "line.h"
#include  "point.h"
#include  "bbox.h"
#include  "ftree.h"
//#include  "TreeDiam.h"
//#include  "glwindow.h"
#include  "glbox.h"
#include  "misc.h"

//#include  "terrain.h"
#include  "distance.h"
#include  "algorithm.h"
#include  "3dsload.h"
#include  "glwindow_geometry.h"
#include  "sarray.t"
#include  "strech.h"
//#include  "bbox.h"

/*--- Start of Code ---*/


static void   get_line( FILE  * fl, char  * line )
{
    char  * out;

    out = fgets( line, 1024, fl );
    assert( out != NULL );
}

static void  transform_pnt( const H3dsVert   & v,
                            Point3d  & pnt )
{
    pnt.setCoord( 0, v.x );
    pnt.setCoord( 1, v.y );
    pnt.setCoord( 2, v.z );
}



void  get_obj_ratio( H3dsMeshObj  & obj, double  & ratio ) 
{
    ratio = 1;
}


void  get_scene_ratios( H3dsScene * scene )
{
    //int  verts_num;
    //bool   f_first;
    double  ratio, max_ratio;

    max_ratio = 0;

    printf( "\n\n\n\n\nScene objects: %d\n", scene->meshobjs );
    for  ( int  ind = 0; ind < scene->meshobjs; ind++ ) {
        H3dsMeshObj  & obj( scene->meshobjlist[ ind ] );

        printf( "faces: %d\n", obj.faces );
        get_obj_ratio( obj, ratio );
        if  ( ( ind == 0 )  ||  (ratio > max_ratio ) ) {
            max_ratio = ratio;
        }
    }
}


int        comp_vertices( const  Point3d  & a,
                          const  Point3d  & b )
{
    if  ( a.coords[ 0 ] < b.coords[ 0 ] )
        return  -1;
    if  ( a.coords[ 0 ] > b.coords[ 0 ] )
        return  1;

    if  ( a.coords[ 1 ] < b.coords[ 1 ] )
        return  -1;
    if  ( a.coords[ 1 ] > b.coords[ 1 ] )
        return  1;
    
    if  ( a.coords[ 2 ] < b.coords[ 2 ] )
        return  -1;
    if  ( a.coords[ 2 ] > b.coords[ 2 ] )
        return  1;

    //printf( "bogi\n" );

    return  0;   
}


void   get_all_vertices( H3dsScene   * scene, 
                         ArrPoint3d  & arr_out )
{
    ArrPoint3d  arr;
    Point3d pnt;

    arr.init( 100, 324 );    
    arr_out.init( 100, 366 );

    for  ( int  ind = 0; ind < scene->meshobjs; ind++ ) {
        H3dsMeshObj  & obj( scene->meshobjlist[ ind ] );


        for  ( int  ind = 0; ind < obj.faces; ind++ ) {
            H3dsFace   & face( obj.facelist[ ind ] );

            H3dsVert   & v0( obj.vertlist[ face.p0 ] );
            H3dsVert   & v1( obj.vertlist[ face.p1 ] );
            H3dsVert   & v2( obj.vertlist[ face.p2 ] );
            
            transform_pnt( v0, pnt );                    
            arr.pushx( pnt );

            transform_pnt( v1, pnt );                    
            arr.pushx( pnt );

            transform_pnt( v2, pnt );                    
            arr.pushx( pnt );
        }
    }        

    arr.quickSort( comp_vertices );
    for  ( int  ind = 0; ind < (arr.size() - 1); ind++ ) {
        if   ( ind == 0 ) {
            arr_out.pushx( arr[ ind ] );
            continue;
        }
        if  ( ! arr[ ind ].isEqual( arr[ ind - 1 ] ) ) 
            arr_out.pushx( arr[ ind ] );
    }

    for  ( int  ind = 0; ind < (arr_out.size() - 1); ind++ ) {
        if  ( arr_out[ ind ].isEqual( arr_out[ ind + 1 ] ) ) {
            printf( "Vertices are equal!\nBIG ERROR\n" );
            printf( "ind : %d\n", ind );
            arr_out[ ind ].print();
            arr_out[ ind + 1 ].print();

            exit( -1 );
        } 
    }
    printf( "Array size: %d\n", (int)arr.size() );
}


class  SceneInfo
{
public:
    ArrPoint3d  * p_arr;
    H3dsScene  * scene;
    int  size;
    BBox3d  bbox;
    
    double  * nn_dist;
    double  * longest_edge;   
    double  snap_dist, global_vertex_ratio;

    void  fill_info( H3dsScene   * _scene );
    int   get_pnt_ind( const Point3d  & a );
    void  register_longest_edge( Point3d  & a,
                                 Point3d  & b );
    void  register_longest_edge_all();
    void  computeRatio();

    void  register_len( double  dist, double  & len_min,
                        double  & len_max ) ;
    void  get_longest_shortest_edge( double  & len_min, 
                               double  & len_max );

};


inline void  SceneInfo::register_len( double  dist, double  & len_min,
                                      double  & len_max ) 
{
    if  ( dist < snap_dist ) 
        return;
    if  ( dist < len_min )
        len_min = dist;
    if  ( dist > len_max )
        len_max = dist;
}


void  SceneInfo::get_longest_shortest_edge( double  & len_min, 
                                            double  & len_max )
{
    //double  max_len, len;
    bool   f_first;

    f_first = true;
    for  ( int  ind = 0; ind < scene->meshobjs; ind++ ) {
        H3dsMeshObj  & obj( scene->meshobjlist[ ind ] );

        for  ( int  ind = 0; ind < obj.faces; ind++ ) {
            H3dsFace   & face( obj.facelist[ ind ] );

            H3dsVert   & v0( obj.vertlist[ face.p0 ] );
            H3dsVert   & v1( obj.vertlist[ face.p1 ] );
            H3dsVert   & v2( obj.vertlist[ face.p2 ] );

            Point3d  pnts[ 3 ];
            
            transform_pnt( v0, pnts[ 0 ] );
            transform_pnt( v1, pnts[ 1 ] );
            transform_pnt( v2, pnts[ 2 ] );
            
            if  ( f_first ) {
                len_min = len_max = pnt_distance( pnts[ 0 ], pnts[ 1 ] );
                f_first = false;
            }
            register_len( pnt_distance( pnts[ 0 ], pnts[ 1 ] ),
                          len_min, len_max );
            register_len( pnt_distance( pnts[ 1 ], pnts[ 2 ] ),
                          len_min, len_max );
            register_len( pnt_distance( pnts[ 2 ], pnts[ 0 ] ),
                          len_min, len_max );
        }
    }    
}



int    SceneInfo::get_pnt_ind( const Point3d  & a )
{
    int  pos;
    
    pos = p_arr->binarySearch( a, comp_vertices );
    while  ( pos > 0 ) {
        if  ( pnt_distance( (*p_arr)[ pos ],
                            (*p_arr)[ pos - 1 ] ) < snap_dist ) 
            pos--;
        else
            break;
    }

    return  pos;
}


void   SceneInfo::register_longest_edge( Point3d  & a,
                                         Point3d  & b )
{
    int  a_ind, b_ind;

    a_ind = get_pnt_ind( a );
    b_ind = get_pnt_ind( b );

    assert( a_ind >= 0 );
    if  ( b_ind < 0 ) {
        b.print();
        printf( "\n");
        for  ( int  ind = 0; ind < size; ind++ ) {
            printf( "\n%d  ", ind );
            (*p_arr)[ ind ].print();
        }

    }

    assert( b_ind >= 0 );

    double  len = pnt_distance( a, b );
    if  ( len > longest_edge[ a_ind ] )
        longest_edge[ a_ind ] = len;
    if  ( len > longest_edge[ b_ind ] )
        longest_edge[ b_ind ] = len;
}


void   SceneInfo::register_longest_edge_all()
{
    for  ( int  ind = 0; ind < scene->meshobjs; ind++ ) {
        H3dsMeshObj  & obj( scene->meshobjlist[ ind ] );

        for  ( int  ind = 0; ind < obj.faces; ind++ ) {
            H3dsFace   & face( obj.facelist[ ind ] );

            H3dsVert   & v0( obj.vertlist[ face.p0 ] );
            H3dsVert   & v1( obj.vertlist[ face.p1 ] );
            H3dsVert   & v2( obj.vertlist[ face.p2 ] );

            Point3d  pnts[ 3 ];
            
            transform_pnt( v0, pnts[ 0 ] );
            transform_pnt( v1, pnts[ 1 ] );
            transform_pnt( v2, pnts[ 2 ] );

            register_longest_edge( pnts[ 0 ], pnts[ 1 ] );
            register_longest_edge( pnts[ 1 ], pnts[ 2 ] );
            register_longest_edge( pnts[ 2 ], pnts[ 0 ] );
        }
    }

}


void   SceneInfo::fill_info( H3dsScene   * _scene )
{
    scene = _scene;

    snap_dist = 0.0001;
    p_arr = new  ArrPoint3d;

    get_all_vertices( scene, *(p_arr) );    
    size = (int)p_arr->size();

    // Compute bounding box
    bbox.init();
    for  ( int  ind = 0; ind < size; ind++ ) 
        bbox.bound( (*p_arr)[ ind ] );
    snap_dist = bbox.get_diam() / 1000000.0;

    printf( "snap_dist: %g\n", snap_dist );

    nn_dist = (double *)malloc( sizeof( double ) * size );
    assert( nn_dist != NULL );
    longest_edge = (double *)malloc( sizeof( double ) * size );
    assert( longest_edge != NULL );

    for  ( int  ind = 0; ind < size; ind++ ) {
        nn_dist[ ind ] = 10e50;
        longest_edge[ ind ] = 0;
    }
    
    printf( "computing NN... would take a while.\n" );
    for  ( int  ind = 0; ind < size; ind++ ) {
        if  ( ( ind & 0x7 ) == 0 )
            printf( "ind: %d/%d\n", ind, size );
        for  ( int  jnd = 0; jnd < size; jnd++ ) {
            if  ( ind == jnd ) 
                continue;
            double  len = pnt_distance( (*p_arr)[ ind ], (*p_arr)[ jnd ] );
            if  ( len < snap_dist ) 
                continue;
            if  ( len < nn_dist[ ind ] )
                nn_dist[ ind ] = len;
        }
    }

    //printf( "Computing longest edges for every vertex.\n" );
    register_longest_edge_all();
}


void   SceneInfo::computeRatio()
{
    double  ratio, max_ratio;

    max_ratio = 0;

    for  ( int  ind = 0; ind < size; ind++ ) {
        ratio = longest_edge[ ind ] / nn_dist[ ind ];
        if  ( ind == 0 ) {
            max_ratio = ratio;
            continue;
        }
        if  ( longest_edge[ ind ] == 0 ) 
            continue;
        //printf( "%05d: %10g ", ind, ratio );
        //(*p_arr)[ ind ].print();
        if  ( ratio > 300.0 ) {
            printf( "  XXXXX" );
            printf( "\n" );
            printf( "isEqual? %d\n", (int)(*p_arr)[ ind ].isEqual(  
                                       (*p_arr)[ ind - 1 ] ) );
            printf( "\t%g\n", pnt_distance( (*p_arr)[ ind ], 
                                        (*p_arr)[ ind - 1 ] ) );
            printf( "isEqual? %d\n", (int)(*p_arr)[ ind ].isEqual(  
                                       (*p_arr)[ ind + 1 ] ) );
            printf( "\t%g\n", pnt_distance( (*p_arr)[ ind ], 
                                        (*p_arr)[ ind + 1 ] ) );
            printf( "Longest_edge: %g\n", longest_edge[ ind ] );
            printf( "nn dist     : %g\n", nn_dist[ ind ] );

            printf( "\n\n\n\n" );
        }
        //else
        //    printf( "\n" );
        if  ( ratio > max_ratio )
            max_ratio = ratio;
    }

    printf( "Max ratio: %g\n", max_ratio );
    global_vertex_ratio = max_ratio;
}


SceneInfo   * CompSceneInfo( H3dsScene   * scene )
{
    SceneInfo  * info;

    info = new SceneInfo;
    info->fill_info( scene );

    return  info;
}


void   ThreeDs_get_stats( char  * filename )
{
    double  len_min, len_max;
    H3dsScene   * scene;

    //set_global_translate( 0, 0, 0 );
    //set_global_scale( 1.0 );

    scene = ThreeDS_ReadFromFile( filename );
    assert( scene != NULL );

    get_scene_ratios( scene );
    //get_scene_longest_shortest_edge( scene, len_min, len_max );

    //ArrPoint3d  points;

    SceneInfo   * info = CompSceneInfo( scene );


    //    info->computeLongestShortestEdge();
    info->computeRatio();


    info->get_longest_shortest_edge( len_min, len_max );
    printf( "len_min: %g   len_max: %g\n", len_min, len_max );

    (void)info;

    printf( "RES: [%20s]  %12g  %12g   vert#: %d\n",
            filename, 
            len_max / len_min,
            info->global_vertex_ratio,
            info->size );
            
    exit( -1 );           
}




int  compDouble( const double  & a, const double  & b )
{
    if  ( a < b ) 
        return  1;
    if  ( a > b )
        return  -1;
    return  0;
}


void  PolyModel::print_stat( const char  * filename )
{
    printf( "\n\n" );
    printf( "Longest edge: %g  shrotest edge: %g\n", longest_edge,
            shortest_edge );

    global_ratio = longest_edge / shortest_edge;
    printf( "global_ratio = %g\n", global_ratio );

    edge_ratio = 0;
    int  skip_count;

    Array<double>   arr_rt;
    arr_rt.init( vertices_num, 24352 );

    double   max_rt;

    max_rt = -1;
    worst_vertex = -1;
    skip_count = 0;
    for  ( int  ind = 0; ind < vertices_num; ind++ ) {
        double  rt;

        if  ( p_dist_nn[ ind ] == 0.0 ) {
            skip_count++;
            continue;
        }

        rt = p_longest_edge[ ind ] / p_dist_nn[ ind ];

        if  ( rt > max_rt ) {
            worst_vertex = ind;
            max_rt = rt;
        }
        arr_rt.pushx( rt );

        if  ( rt > edge_ratio )
            edge_ratio = rt;
    }

    printf( "%d vertices were skipped\n", skip_count );
    printf( "[%-20s] se/le: %12.5g  max vert rt : %12.5g\n",
            filename, global_ratio, edge_ratio );

    arr_rt.quickSort( compDouble );

    int  start, end;
    double  limit;

    end = start = 0;
    while  ( end < (int)( arr_rt.size() - 1 ) ) {
        limit = arr_rt[ start ] * 0.8;
        end = start;
        while  ( ( arr_rt[ end ] >= limit )  
                 &&  ( end < (int)(arr_rt.size() - 1 ) ) )
            end++;
        printf( "Range: %10.5g - %10.5g: %6d\n", 
                arr_rt[ start ], arr_rt[ end - 1 ], end - start );
        start = end;
    }

    //for  ( int  ind = 0; ind < 100; ind++ )
    //    printf( "%d: %g\n", ind, arr_rt[ ind ] );

}


void  PolyModel::register_edge( int  a, int  b )
{
    double  len;

    //printf( "registreing edge( %d, %d)  vertices: %d\n", a, b,
    //        (int)vertices.size() );
    len = pnt_distance( vertices[ a ], vertices[ b ] );
    if  ( len > p_longest_edge[ a ] ) 
        p_longest_edge[ a ] = len;
    if  ( len > p_longest_edge[ b ] ) 
        p_longest_edge[ b ] = len;
    
    //printf( "bogi1\n" );
    if  ( f_first_edge_registeration ) {
        f_first_edge_registeration = false;
        longest_edge = shortest_edge = len;
    }

    //printf( "bogi2\n" );

    if  ( len > 0.0 ) {
        if  ( len > longest_edge )
            longest_edge = len;
        if  ( len < shortest_edge )
            shortest_edge = len;
    }
}


void  PolyModel::compute_longest_edges()
{
    //printf( "computing longest edges\n" );

    p_longest_edge = (double *)malloc( sizeof( double ) * vertices_num );
    assert( p_longest_edge != NULL );

    for  ( int  ind = 0; ind < vertices_num; ind++ )
        p_longest_edge[ ind ] = 0;

    for  ( int  ind = 0; ind < faces_num; ind++ ) {
        //printf( "ind: %d\n", ind );
        //printf( "faces.size: %d\n", (int)faces.size() );
        register_edge( faces[ ind ].a, faces[ ind ].b );
        register_edge( faces[ ind ].b, faces[ ind ].c );
        register_edge( faces[ ind ].c, faces[ ind ].a );
    }
}


void   PolyModel::find_bbox_nn( Point3d  & pnt, 
                                 int  vert_id, 
                                 double  & curr,
                                 int  bbox_ind )
{
    int  start, end;
    
    start = getBBoxStart( bbox_ind );
    end   = getBBoxEnd( bbox_ind );
    
    for  ( int  jnd = start; jnd <= end; jnd++ ) {
        if  ( jnd == vert_id ) 
            continue;
        double  dist = pnt_distance( pnt, vertices[ jnd ] );
        if  ( dist < curr ) 
            curr = dist;
    }
}


double  PolyModel::find_nn( int   vert_id ) 
{
    Point3d  & pnt( vertices[ vert_id ] );
    double  curr;
    int  chunk_done;

    curr = pnt_distance( pnt, vertices[ 0 ] );
    chunk_done = vert_id / BBOX_CHUNK;
    find_bbox_nn( pnt, vert_id, curr, chunk_done );

    for  ( int  ind = 0; ind < boxes_num; ind++ ) {
        if  ( ind == chunk_done )
            continue;
        Point3d   proj = vert_bboxes[ ind ].project( pnt );
        
        if  ( pnt_distance( pnt, proj ) > curr ) 
            continue;

        find_bbox_nn( pnt, vert_id, curr, ind  );
    }

    return  curr;
}


void    PolyModel::find_nn_all()
{
    p_dist_nn = (double *)malloc( sizeof( double ) * vertices_num );
    assert( p_dist_nn != NULL );

    //printf( "Computing NN...\n" );
    for  ( int  ind = 0; ind < vertices_num; ind++ ) {
        if  ( ( ind & 0x7ff ) == 0 ) {
            printf( "%7d     \r", ind );
            fflush( stdout );
        }
        p_dist_nn[ ind ] = find_nn( ind );
    }

}


void  PolyModel::init_vertices_bboxes()
{
    boxes_num = ((vertices_num - 1) / BBOX_CHUNK) + 1;
    vert_bboxes.init( boxes_num, 85947 );

    for  ( int  ind = 0; ind < boxes_num; ind++ ) {
        int  start, end;

        start = getBBoxStart( ind );
        end   = getBBoxEnd( ind );

        BBox3d   bb;
        bb.init();
        for  ( int  jnd = start; jnd <= end; jnd++ ) 
            bb.bound( vertices[ jnd ] );

        vert_bboxes.pushx( bb );
    }
}



void  PolyModel::read_poly_file( const char  * filename )
{
    FILE  * fl;
    char  line[ LINE_SIZE ];
    int  args;

    printf( "Model: %s\n", filename );
    //printf( "bogi\n" );
    vertices.init( 10, 3454 );
    faces.init( 20, 53332 );

    fl = fopen( filename, "rt" );
    if  ( fl == NULL ) {
        fprintf( stderr, "Unable to open file: [%s]\n",
                 filename );
        exit( -1 );
    }

    line[ 0 ] = 0;
    vertices_num = faces_num = -1;
    //printf( "mogi\n" );
    //fflush( stdout );
    while  ( ( ! feof( fl ) )  
             &&  ( ! str_prefix_eq( line, "end_header" ) ) ) {
        get_line( fl, line );

        //printf( "shogi\n" );
        if  ( str_prefix_eq( line, "element vertex" ) ) {
            args = sscanf( line, "element vertex %d", &vertices_num );
            if  ( args < 1 ) {
                fprintf( stderr, "Vertex num info non decipherable!\n" );
                exit( -1 );
            }
            assert( vertices_num > 0 );
        }
              
        if  ( str_prefix_eq( line, "element face" ) ) {
            args = sscanf( line, "element face %d", &faces_num );
            if  ( args < 1 ) {
                fprintf( stderr, "Vertex num info non decipherable!\n" );
                exit( -1 );
            }
            assert( faces_num > 0 );
        }         
    }
    
    if  ( feof( fl ) ) {
        fprintf( stderr, "Vertex/face num info not found!\n" );
        exit( -1 );
    }
    if  ( vertices_num < 0 ) {
        printf( "Vertices # not found!\n" );
        exit( -1 );
    }
    if  ( faces_num < 0 ) {
        printf( "Faces # not found!\n" );
        exit( -1 );
    }

    printf( "Model: Vertices #: %d  Faces #: %d\n", vertices_num, faces_num );
     
    //printf( "Reading vertices\n" );
    // read the vertices
    for  ( int  ind = 0; ind < vertices_num; ind++ ) {
        double  x, y, z;

        get_line( fl, line );
        if  ( feof( fl ) ) {
            fprintf( stderr, "unexpected end of file!\n" );
            exit( -1 );
        }
        args = sscanf( line, "%lg %lg %lg", &x, &y, &z );
        Point3d  pnt;
        pnt.setCoord( 0, x  );
        pnt.setCoord( 1, y );
        pnt.setCoord( 2, z );

        vertices.pushx( pnt );
    }
    // read the vertices
    //printf( "Reading faces\n" );
    for  ( int  ind = 0; ind < faces_num; ind++ ) {
        int  a, b, c, r;

        get_line( fl, line );
        if  ( feof( fl ) ) {
            fprintf( stderr, "unexpected end of file!\n" );
            exit( -1 );
        }
        args = sscanf( line, "%d %d %d %d", &r, &a, &b, &c );
        assert( r == 3 );

        FaceIds  fi;

        fi.a = a;
        fi.b = b;
        fi.c = c;

        assert( ( 0 <= a )  &&  ( a < vertices_num ) );
        assert( ( 0 <= b )  &&  ( b < vertices_num ) );
        assert( ( 0 <= c )  &&  ( c < vertices_num ) );
 
        faces.pushx( fi );
    }
    printf( "Reading done!\n" );
}


bool  str_prefix_eq( char  * line, char  * prefix )
{
    while  ( *prefix ) {
        if  ( *line != *prefix )
            return  false;
        line++;
        prefix++;
    }
    return  true;
}


void   ply_get_stats( char  * filename )
{
    PolyModel  * p_model;
    Timer  tm;

    tm.start();

    p_model = new PolyModel;
    
    p_model->init();

    p_model->read_poly_file( filename );
    p_model->init_vertices_bboxes();
    p_model->find_nn_all();
    p_model->compute_longest_edges();
    //p_model->compute_longest_edges();
    p_model->print_stat( filename );

    tm.end();

    printf( "Time: %g\n", tm.seconds() );
}


void   PolyModel::computeBBox()
{
    modelBB.init();

    for  ( int  ind = 0; ind < vertices.size(); ind++ )
        modelBB.bound( vertices[ ind ] );
}



/* strech.C - End of File ------------------------------------------*/
